package cn.superdesk.uniorder.dao.entity.marketing.department;

import java.util.ArrayList;
import java.util.List;

public class UnifiedAreaCityVirtExample {
    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    protected String orderByClause;

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    protected boolean distinct;

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public UnifiedAreaCityVirtExample() {
        oredCriteria = new ArrayList<>();
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andVirtIdIsNull() {
            addCriterion("virt_id is null");
            return (Criteria) this;
        }

        public Criteria andVirtIdIsNotNull() {
            addCriterion("virt_id is not null");
            return (Criteria) this;
        }

        public Criteria andVirtIdEqualTo(Long value) {
            addCriterion("virt_id =", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdNotEqualTo(Long value) {
            addCriterion("virt_id <>", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdGreaterThan(Long value) {
            addCriterion("virt_id >", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdGreaterThanOrEqualTo(Long value) {
            addCriterion("virt_id >=", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdLessThan(Long value) {
            addCriterion("virt_id <", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdLessThanOrEqualTo(Long value) {
            addCriterion("virt_id <=", value, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdIn(List<Long> values) {
            addCriterion("virt_id in", values, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdNotIn(List<Long> values) {
            addCriterion("virt_id not in", values, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdBetween(Long value1, Long value2) {
            addCriterion("virt_id between", value1, value2, "virtId");
            return (Criteria) this;
        }

        public Criteria andVirtIdNotBetween(Long value1, Long value2) {
            addCriterion("virt_id not between", value1, value2, "virtId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdIsNull() {
            addCriterion("area_city_id is null");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdIsNotNull() {
            addCriterion("area_city_id is not null");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdEqualTo(Long value) {
            addCriterion("area_city_id =", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdNotEqualTo(Long value) {
            addCriterion("area_city_id <>", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdGreaterThan(Long value) {
            addCriterion("area_city_id >", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdGreaterThanOrEqualTo(Long value) {
            addCriterion("area_city_id >=", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdLessThan(Long value) {
            addCriterion("area_city_id <", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdLessThanOrEqualTo(Long value) {
            addCriterion("area_city_id <=", value, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdIn(List<Long> values) {
            addCriterion("area_city_id in", values, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdNotIn(List<Long> values) {
            addCriterion("area_city_id not in", values, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdBetween(Long value1, Long value2) {
            addCriterion("area_city_id between", value1, value2, "areaCityId");
            return (Criteria) this;
        }

        public Criteria andAreaCityIdNotBetween(Long value1, Long value2) {
            addCriterion("area_city_id not between", value1, value2, "areaCityId");
            return (Criteria) this;
        }
    }

    /**
     *
     * table unified_area_city_virt
     *
     * do_not_delete_during_merge Tue Nov 24 16:45:56 CST 2020
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
     *
     * table unified_area_city_virt
     *
     * Tue Nov 24 16:45:56 CST 2020
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}